package org.processmining.xeslite.query;

import org.processmining.xeslite.query.syntax.ParseException;

import com.googlecode.cqengine.index.Index;
import com.googlecode.cqengine.query.Query;
import com.googlecode.cqengine.resultset.ResultSet;

public interface XIndexedAttributable<T> {

	/**
	 * @param index
	 */
	public abstract void addIndex(Index<T> index);

	/**
	 * @param query
	 * @return
	 */
	public abstract ResultSet<T> retrieve(Query<T> query);

	/**
	 * @param query
	 * @return
	 * @throws ParseException
	 */
	Query<T> parseQuery(String query) throws ParseException;

	/**
	 * @param query
	 * @param attributeTypeResolver
	 * @return
	 * @throws ParseException
	 */
	Query<T> parseQuery(String query, AttributeTypeResolver attributeTypeResolver) throws ParseException;
	
	/**
	 * @param query
	 * @return
	 * @throws ParseException
	 */
	public abstract ResultSet<T> retrieve(String query) throws ParseException;

	/**
	 * @param element
	 * @return
	 */
	public abstract boolean remove(T element);

	/**
	 * Add an element
	 *
	 * @param element
	 */
	public abstract void add(T element);

}